Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/guide_loc_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/guide_loc_mod.F90	(revision 5116)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/guide_loc_mod.F90	(revision 5117)
@@ -1412,163 +919,646 @@
     include "comgeom2.h"
 
-! input arguments :
+    REAL, DIMENSION (iip1, jjb_u:jje_u), INTENT(IN) :: psi ! Psol gcm
+    REAL, DIMENSION (iip1, jjb_u:jje_u, llm), INTENT(IN) :: teta ! Temp. Pot. gcm
+
+    LOGICAL, SAVE :: first = .TRUE.
+    !$OMP THREADPRIVATE(first)
+    ! Variables pour niveaux pression:
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: plnc1, plnc2 !niveaux pression guidage
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: plunc, plsnc !niveaux pression modele
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: plvnc       !niveaux pression modele
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: p           ! pression intercouches
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: pls, pext   ! var intermediaire
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: pbarx
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: pbary
+    ! Variables pour fonction Exner (P milieu couche)
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: pk
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :) :: pks
+    REAL :: unskap
+    ! Pression de vapeur saturante
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :) :: qsat
+    !Variables intermediaires interpolation
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: zu1, zu2
+    REAL, ALLOCATABLE, SAVE, DIMENSION (:, :, :) :: zv1, zv2
+
+    INTEGER :: i, j, l, ij
+    CHARACTER(LEN = 20), PARAMETER :: modname = "guide_interp"
+    TYPE(Request), SAVE :: Req
+    !$OMP THREADPRIVATE(Req)
+
+    IF (is_master) WRITE(*, *)trim(modname) // ': interpolate nudging variables'
+    ! -----------------------------------------------------------------
+    ! Calcul des niveaux de pression champs guidage (pour T et Q)
+    ! -----------------------------------------------------------------
+    IF (first) THEN
+      !$OMP MASTER
+      ALLOCATE(plnc1(iip1, jjb_u:jje_u, nlevnc))
+      ALLOCATE(plnc2(iip1, jjb_u:jje_u, nlevnc))
+      ALLOCATE(plunc(iip1, jjb_u:jje_u, llm))
+      ALLOCATE(plsnc(iip1, jjb_u:jje_u, llm))
+      ALLOCATE(plvnc(iip1, jjb_v:jje_v, llm))
+      ALLOCATE(p(iip1, jjb_u:jje_u, llmp1))
+      ALLOCATE(pls(iip1, jjb_u:jje_u, llm))
+      ALLOCATE(pext(iip1, jjb_u:jje_u, llm))
+      ALLOCATE(pbarx(iip1, jjb_u:jje_u, llm))
+      ALLOCATE(pbary(iip1, jjb_v:jje_v, llm))
+      ALLOCATE(pk(iip1, jjb_u:jje_u, llm))
+      ALLOCATE(pks (iip1, jjb_u:jje_u))
+      ALLOCATE(qsat(ijb_u:ije_u, llm))
+      ALLOCATE(zu1(iip1, jjb_u:jje_u, llm))
+      ALLOCATE(zu2(iip1, jjb_u:jje_u, llm))
+      ALLOCATE(zv1(iip1, jjb_v:jje_v, llm))
+      ALLOCATE(zv2(iip1, jjb_v:jje_v, llm))
+      !$OMP END MASTER
+      !$OMP BARRIER
+    ENDIF
+
+    IF (guide_plevs==0) THEN
+      !$OMP DO
+      DO l = 1, nlevnc
+        DO j = jjbu, jjeu
+          DO i = 1, iip1
+            plnc2(i, j, l) = apnc(l)
+            plnc1(i, j, l) = apnc(l)
+          ENDDO
+        ENDDO
+      ENDDO
+    ENDIF
+
+    IF (first) THEN
+      first = .FALSE.
+      !$OMP MASTER
+      WRITE(*, *)trim(modname) // ' : check vertical level order'
+      WRITE(*, *)trim(modname) // ' LMDZ :'
+      do l = 1, llm
+        WRITE(*, *)trim(modname) // ' PL(', l, ')=', (ap(l) + ap(l + 1)) / 2. &
+                + psi(1, jjeu) * (bp(l) + bp(l + 1)) / 2.
+      enddo
+      WRITE(*, *)trim(modname) // ' nudging file :'
+      SELECT CASE (guide_plevs)
+      CASE (0)
+        do l = 1, nlevnc
+          WRITE(*, *)trim(modname) // ' PL(', l, ')=', plnc2(1, jjbu, l)
+        enddo
+      CASE (1)
+        DO l = 1, nlevnc
+          WRITE(*, *)trim(modname) // ' PL(', l, ')=', &
+                  apnc(l) + bpnc(l) * psnat2(1, jjbu)
+        ENDDO
+      CASE (2)
+        do l = 1, nlevnc
+          WRITE(*, *)trim(modname) // ' PL(', l, ')=', pnat2(1, jjbu, l)
+        enddo
+      END SELECT
+      WRITE(*, *)trim(modname) // ' invert ordering: invert_p=', invert_p
+      IF (guide_u) THEN
+        do l = 1, nlevnc
+          WRITE(*, *)trim(modname) // ' U(', l, ')=', unat2(1, jjbu, l)
+        enddo
+      endif
+      IF (guide_T) THEN
+        do l = 1, nlevnc
+          WRITE(*, *)trim(modname) // ' T(', l, ')=', tnat2(1, jjbu, l)
+        enddo
+      endif
+      !$OMP END MASTER
+    endif ! of if (first)
+
+    IF (guide_plevs /= 1 .OR. guide_t .AND. .NOT. guide_teta &
+            .OR. guide_q .AND. guide_hr) THEN
+      CALL pression_loc(ijnb_u, ap, bp, psi, p)
+      IF (disvert_type==1) THEN
+        CALL exner_hyb_loc(ijnb_u, psi, p, pks, pk)
+      else ! we assume that we are in the disvert_type==2 case
+        CALL exner_milieu_loc(ijnb_u, psi, p, pks, pk)
+      endif
+    end if
+
+    ! -----------------------------------------------------------------
+    ! Calcul niveaux pression modele
+    ! -----------------------------------------------------------------
+
+    !    ....  Calcul de pls , pression au milieu des couches ,en Pascals
+    IF (guide_plevs==1) THEN
+      !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l = 1, llm
+        DO j = jjbu, jjeu
+          DO i = 1, iip1
+            pls(i, j, l) = (ap(l) + ap(l + 1)) / 2. + psi(i, j) * (bp(l) + bp(l + 1)) / 2.
+          ENDDO
+        ENDDO
+      ENDDO
+    ELSE
+      unskap = 1. / kappa
+      !$OMP BARRIER
+      !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l = 1, llm
+        DO j = jjbu, jjeu
+          DO i = 1, iip1
+            pls(i, j, l) = preff * (pk(i, j, l) / cpp) ** unskap
+          ENDDO
+        ENDDO
+      ENDDO
+    ENDIF
+
+    !   calcul des pressions pour les grilles u et v
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    do l = 1, llm
+      do j = jjbu, jjeu
+        do i = 1, iip1
+          pext(i, j, l) = pls(i, j, l) * aire(i, j)
+        enddo
+      enddo
+    enddo
+
+    CALL Register_Hallo_u(pext, llm, 1, 2, 2, 1, Req)
+    CALL SendRequest(Req)
+    !$OMP BARRIER
+    CALL WaitRequest(Req)
+    !$OMP BARRIER
+
+    CALL massbar_loc(pext, pbarx, pbary)
+    !$OMP BARRIER
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    do l = 1, llm
+      do j = jjbu, jjeu
+        do i = 1, iip1
+          plunc(i, j, l) = pbarx(i, j, l) / aireu(i, j)
+          plsnc(i, j, l) = pls(i, j, l)
+        enddo
+      enddo
+    enddo
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    do l = 1, llm
+      do j = jjbv, jjev
+        do i = 1, iip1
+          plvnc(i, j, l) = pbary(i, j, l) / airev(i, j)
+        enddo
+      enddo
+    enddo
+
+    ! -----------------------------------------------------------------
+    ! Interpolation verticale champs guidage sur niveaux modele
+    ! Conversion en variables gcm (ucov, vcov...)
+    ! -----------------------------------------------------------------
+    IF (guide_P) THEN
+      !$OMP MASTER
+      do j = jjbu, jjeu
+        do i = 1, iim
+          ij = (j - 1) * iip1 + i
+          psgui1(ij) = psnat1(i, j)
+          psgui2(ij) = psnat2(i, j)
+        enddo
+        psgui1(iip1 * j) = psnat1(1, j)
+        psgui2(iip1 * j) = psnat2(1, j)
+      enddo
+      !$OMP END MASTER
+      !$OMP BARRIER
+    endif
+
+    IF (guide_T) THEN
+      ! Calcul des nouvelles valeurs des niveaux de pression du guidage
+      IF (guide_plevs==1) THEN
+        !$OMP DO
+        DO l = 1, nlevnc
+          DO j = jjbu, jjeu
+            DO i = 1, iip1
+              plnc2(i, j, l) = apnc(l) + bpnc(l) * psnat2(i, j)
+              plnc1(i, j, l) = apnc(l) + bpnc(l) * psnat1(i, j)
+            ENDDO
+          ENDDO
+        ENDDO
+      ELSE IF (guide_plevs==2) THEN
+        !$OMP DO
+        DO l = 1, nlevnc
+          DO j = jjbu, jjeu
+            DO i = 1, iip1
+              plnc2(i, j, l) = pnat2(i, j, l)
+              plnc1(i, j, l) = pnat1(i, j, l)
+            ENDDO
+          ENDDO
+        ENDDO
+      ENDIF
+
+      ! Interpolation verticale
+      !$OMP MASTER
+      CALL pres2lev(tnat1(:, jjbu:jjeu, :), zu1(:, jjbu:jjeu, :), nlevnc, llm, &
+              plnc1(:, jjbu:jjeu, :), plsnc(:, jjbu:jjeu, :), iip1, jjnu, invert_p)
+      CALL pres2lev(tnat2(:, jjbu:jjeu, :), zu2(:, jjbu:jjeu, :), nlevnc, llm, &
+              plnc2(:, jjbu:jjeu, :), plsnc(:, jjbu:jjeu, :), iip1, jjnu, invert_p)
+      !$OMP END MASTER
+      !$OMP BARRIER
+      ! Conversion en variables GCM
+      !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      do l = 1, llm
+        do j = jjbu, jjeu
+          IF (guide_teta) THEN
+            do i = 1, iim
+              ij = (j - 1) * iip1 + i
+              tgui1(ij, l) = zu1(i, j, l)
+              tgui2(ij, l) = zu2(i, j, l)
+            enddo
+          ELSE
+            do i = 1, iim
+              ij = (j - 1) * iip1 + i
+              tgui1(ij, l) = zu1(i, j, l) * cpp / pk(i, j, l)
+              tgui2(ij, l) = zu2(i, j, l) * cpp / pk(i, j, l)
+            enddo
+          ENDIF
+          tgui1(j * iip1, l) = tgui1((j - 1) * iip1 + 1, l)
+          tgui2(j * iip1, l) = tgui2((j - 1) * iip1 + 1, l)
+        enddo
+        IF (pole_nord) THEN
+          do i = 1, iip1
+            tgui1(i, l) = tgui1(1, l)
+            tgui2(i, l) = tgui2(1, l)
+          enddo
+        endif
+        IF (pole_sud) THEN
+          do i = 1, iip1
+            tgui1(ip1jm + i, l) = tgui1(ip1jm + 1, l)
+            tgui2(ip1jm + i, l) = tgui2(ip1jm + 1, l)
+          enddo
+        endif
+      enddo
+    ENDIF
+
+    IF (guide_Q) THEN
+      ! Calcul des nouvelles valeurs des niveaux de pression du guidage
+      IF (guide_plevs==1) THEN
+        !$OMP DO
+        DO l = 1, nlevnc
+          DO j = jjbu, jjeu
+            DO i = 1, iip1
+              plnc2(i, j, l) = apnc(l) + bpnc(l) * psnat2(i, j)
+              plnc1(i, j, l) = apnc(l) + bpnc(l) * psnat1(i, j)
+            ENDDO
+          ENDDO
+        ENDDO
+      ELSE IF (guide_plevs==2) THEN
+        !$OMP DO
+        DO l = 1, nlevnc
+          DO j = jjbu, jjeu
+            DO i = 1, iip1
+              plnc2(i, j, l) = pnat2(i, j, l)
+              plnc1(i, j, l) = pnat1(i, j, l)
+            ENDDO
+          ENDDO
+        ENDDO
+      ENDIF
+
+      ! Interpolation verticale
+      !$OMP MASTER
+      CALL pres2lev(qnat1(:, jjbu:jjeu, :), zu1(:, jjbu:jjeu, :), nlevnc, llm, &
+              plnc1(:, jjbu:jjeu, :), plsnc(:, jjbu:jjeu, :), iip1, jjnu, invert_p)
+      CALL pres2lev(qnat2(:, jjbu:jjeu, :), zu2(:, jjbu:jjeu, :), nlevnc, llm, &
+              plnc2(:, jjbu:jjeu, :), plsnc(:, jjbu:jjeu, :), iip1, jjnu, invert_p)
+      !$OMP END MASTER
+      !$OMP BARRIER
+
+      ! Conversion en variables GCM
+      ! On suppose qu'on a la bonne variable dans le fichier de guidage:
+      ! Hum.Rel si guide_hr, Hum.Spec. sinon.
+      !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      do l = 1, llm
+        do j = jjbu, jjeu
+          do i = 1, iim
+            ij = (j - 1) * iip1 + i
+            qgui1(ij, l) = zu1(i, j, l)
+            qgui2(ij, l) = zu2(i, j, l)
+          enddo
+          qgui1(j * iip1, l) = qgui1((j - 1) * iip1 + 1, l)
+          qgui2(j * iip1, l) = qgui2((j - 1) * iip1 + 1, l)
+        enddo
+        IF (pole_nord) THEN
+          do i = 1, iip1
+            qgui1(i, l) = qgui1(1, l)
+            qgui2(i, l) = qgui2(1, l)
+          enddo
+        endif
+        IF (pole_sud) THEN
+          do i = 1, iip1
+            qgui1(ip1jm + i, l) = qgui1(ip1jm + 1, l)
+            qgui2(ip1jm + i, l) = qgui2(ip1jm + 1, l)
+          enddo
+        endif
+      enddo
+      IF (guide_hr) THEN
+        !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+        do l = 1, llm
+          CALL q_sat(iip1 * jjnu, teta(:, jjbu:jjeu, l) * pk(:, jjbu:jjeu, l) / cpp, &
+                  plsnc(:, jjbu:jjeu, l), qsat(ijbu:ijeu, l))
+          qgui1(ijbu:ijeu, l) = qgui1(ijbu:ijeu, l) * qsat(ijbu:ijeu, l) * 0.01 !hum. rel. en %
+          qgui2(ijbu:ijeu, l) = qgui2(ijbu:ijeu, l) * qsat(ijbu:ijeu, l) * 0.01
+        enddo
+
+      ENDIF
+    ENDIF
+
+    IF (guide_u) THEN
+      ! Calcul des nouvelles valeurs des niveaux de pression du guidage
+      IF (guide_plevs==1) THEN
+        !$OMP DO
+        DO l = 1, nlevnc
+          DO j = jjbu, jjeu
+            DO i = 1, iim
+              plnc2(i, j, l) = apnc(l) + bpnc(l) * (psnat2(i, j) * aire(i, j) * alpha1p2(i, j) &
+                      + psnat2(i + 1, j) * aire(i + 1, j) * alpha3p4(i + 1, j)) / aireu(i, j)
+              plnc1(i, j, l) = apnc(l) + bpnc(l) * (psnat1(i, j) * aire(i, j) * alpha1p2(i, j) &
+                      + psnat1(i + 1, j) * aire(i + 1, j) * alpha3p4(i + 1, j)) / aireu(i, j)
+            ENDDO
+            plnc2(iip1, j, l) = plnc2(1, j, l)
+            plnc1(iip1, j, l) = plnc1(1, j, l)
+          ENDDO
+        ENDDO
+      ELSE IF (guide_plevs==2) THEN
+        !$OMP DO
+        DO l = 1, nlevnc
+          DO j = jjbu, jjeu
+            DO i = 1, iim
+              plnc2(i, j, l) = (pnat2(i, j, l) * aire(i, j) * alpha1p2(i, j) &
+                      + pnat2(i + 1, j, l) * aire(i, j) * alpha3p4(i + 1, j)) / aireu(i, j)
+              plnc1(i, j, l) = (pnat1(i, j, l) * aire(i, j) * alpha1p2(i, j) &
+                      + pnat1(i + 1, j, l) * aire(i, j) * alpha3p4(i + 1, j)) / aireu(i, j)
+            ENDDO
+            plnc2(iip1, j, l) = plnc2(1, j, l)
+            plnc1(iip1, j, l) = plnc1(1, j, l)
+          ENDDO
+        ENDDO
+      ENDIF
+
+      ! Interpolation verticale
+      !$OMP MASTER
+      CALL pres2lev(unat1(:, jjbu:jjeu, :), zu1(:, jjbu:jjeu, :), nlevnc, llm, &
+              plnc1(:, jjbu:jjeu, :), plunc(:, jjbu:jjeu, :), iip1, jjnu, invert_p)
+      CALL pres2lev(unat2(:, jjbu:jjeu, :), zu2(:, jjbu:jjeu, :), nlevnc, llm, &
+              plnc2(:, jjbu:jjeu, :), plunc(:, jjbu:jjeu, :), iip1, jjnu, invert_p)
+      !$OMP END MASTER
+      !$OMP BARRIER
+
+      ! Conversion en variables GCM
+      !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      do l = 1, llm
+        do j = jjbu, jjeu
+          do i = 1, iim
+            ij = (j - 1) * iip1 + i
+            ugui1(ij, l) = zu1(i, j, l) * cu(i, j)
+            ugui2(ij, l) = zu2(i, j, l) * cu(i, j)
+          enddo
+          ugui1(j * iip1, l) = ugui1((j - 1) * iip1 + 1, l)
+          ugui2(j * iip1, l) = ugui2((j - 1) * iip1 + 1, l)
+        enddo
+        IF (pole_nord) THEN
+          do i = 1, iip1
+            ugui1(i, l) = 0.
+            ugui2(i, l) = 0.
+          enddo
+        endif
+        IF (pole_sud) THEN
+          do i = 1, iip1
+            ugui1(ip1jm + i, l) = 0.
+            ugui2(ip1jm + i, l) = 0.
+          enddo
+        endif
+      enddo
+    ENDIF
+
+    IF (guide_v) THEN
+      ! Calcul des nouvelles valeurs des niveaux de pression du guidage
+      IF (guide_plevs==1) THEN
+        CALL Register_Hallo_u(psnat1, 1, 1, 2, 2, 1, Req)
+        CALL Register_Hallo_u(psnat2, 1, 1, 2, 2, 1, Req)
+        CALL SendRequest(Req)
+        !$OMP BARRIER
+        CALL WaitRequest(Req)
+        !$OMP BARRIER
+        !$OMP DO
+        DO l = 1, nlevnc
+          DO j = jjbv, jjev
+            DO i = 1, iip1
+              plnc2(i, j, l) = apnc(l) + bpnc(l) * (psnat2(i, j) * aire(i, j) * alpha2p3(i, j) &
+                      + psnat2(i, j + 1) * aire(i, j + 1) * alpha1p4(i, j + 1)) / airev(i, j)
+              plnc1(i, j, l) = apnc(l) + bpnc(l) * (psnat1(i, j) * aire(i, j) * alpha2p3(i, j) &
+                      + psnat1(i, j + 1) * aire(i, j + 1) * alpha1p4(i, j + 1)) / airev(i, j)
+            ENDDO
+          ENDDO
+        ENDDO
+      ELSE IF (guide_plevs==2) THEN
+        CALL Register_Hallo_u(pnat1, llm, 1, 2, 2, 1, Req)
+        CALL Register_Hallo_u(pnat2, llm, 1, 2, 2, 1, Req)
+        CALL SendRequest(Req)
+        !$OMP BARRIER
+        CALL WaitRequest(Req)
+        !$OMP BARRIER
+        !$OMP DO
+        DO l = 1, nlevnc
+          DO j = jjbv, jjev
+            DO i = 1, iip1
+              plnc2(i, j, l) = (pnat2(i, j, l) * aire(i, j) * alpha2p3(i, j) &
+                      + pnat2(i, j + 1, l) * aire(i, j) * alpha1p4(i, j + 1)) / airev(i, j)
+              plnc1(i, j, l) = (pnat1(i, j, l) * aire(i, j) * alpha2p3(i, j) &
+                      + pnat1(i, j + 1, l) * aire(i, j) * alpha1p4(i, j + 1)) / airev(i, j)
+            ENDDO
+          ENDDO
+        ENDDO
+      ENDIF
+      ! Interpolation verticale
+
+      !$OMP MASTER
+      CALL pres2lev(vnat1(:, jjbv:jjev, :), zv1(:, jjbv:jjev, :), nlevnc, llm, &
+              plnc1(:, jjbv:jjev, :), plvnc(:, jjbv:jjev, :), iip1, jjnv, invert_p)
+      CALL pres2lev(vnat2(:, jjbv:jjev, :), zv2(:, jjbv:jjev, :), nlevnc, llm, &
+              plnc2(:, jjbv:jjev, :), plvnc(:, jjbv:jjev, :), iip1, jjnv, invert_p)
+      !$OMP END MASTER
+      !$OMP BARRIER
+      ! Conversion en variables GCM
+      !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      do l = 1, llm
+        do j = jjbv, jjev
+          do i = 1, iim
+            ij = (j - 1) * iip1 + i
+            vgui1(ij, l) = zv1(i, j, l) * cv(i, j)
+            vgui2(ij, l) = zv2(i, j, l) * cv(i, j)
+          enddo
+          vgui1(j * iip1, l) = vgui1((j - 1) * iip1 + 1, l)
+          vgui2(j * iip1, l) = vgui2((j - 1) * iip1 + 1, l)
+        enddo
+      enddo
+    ENDIF
+
+  END SUBROUTINE guide_interp
+
+  !=======================================================================
+  SUBROUTINE tau2alpha(typ, pim, jjb, jje, factt, taumin, taumax, alpha)
+
+    ! Calcul des constantes de rappel alpha (=1/tau)
+
+    USE comconst_mod, ONLY: pi
+    USE serre_mod, ONLY: clat, clon, grossismx, grossismy
+
+    IMPLICIT NONE
+
+    include "dimensions.h"
+    include "paramet.h"
+    include "comgeom2.h"
+
+    ! input arguments :
     INTEGER, INTENT(IN) :: typ    ! u(2),v(3), ou scalaire(1)
     INTEGER, INTENT(IN) :: pim ! dimensions en lon
-    INTEGER, INTENT(IN) :: jjb,jje ! dimensions en lat
-    REAL, INTENT(IN)    :: factt   ! pas de temps en fraction de jour
-    REAL, INTENT(IN)    :: taumin,taumax
-! output arguments:
-    REAL, DIMENSION(pim,jjb:jje), INTENT(OUT) :: alpha 
-  
-!  local variables:
-    LOGICAL, SAVE               :: first=.TRUE.
-    REAL, SAVE                  :: gamma,dxdy_min,dxdy_max
-    REAL, DIMENSION (iip1,jjp1) :: zdx,zdy
-    REAL, DIMENSION (iip1,jjp1) :: dxdys,dxdyu
-    REAL, DIMENSION (iip1,jjm)  :: dxdyv
-    real dxdy_
-    real zlat,zlon
-    real alphamin,alphamax,xi
-    integer i,j,ilon,ilat
-    CHARACTER(LEN=20),parameter :: modname="tau2alpha"
-
-
-    alphamin=factt/taumax
-    alphamax=factt/taumin
+    INTEGER, INTENT(IN) :: jjb, jje ! dimensions en lat
+    REAL, INTENT(IN) :: factt   ! pas de temps en fraction de jour
+    REAL, INTENT(IN) :: taumin, taumax
+    ! output arguments:
+    REAL, DIMENSION(pim, jjb:jje), INTENT(OUT) :: alpha
+
+    !  local variables:
+    LOGICAL, SAVE :: first = .TRUE.
+    REAL, SAVE :: gamma, dxdy_min, dxdy_max
+    REAL, DIMENSION (iip1, jjp1) :: zdx, zdy
+    REAL, DIMENSION (iip1, jjp1) :: dxdys, dxdyu
+    REAL, DIMENSION (iip1, jjm) :: dxdyv
+    REAL dxdy_
+    REAL zlat, zlon
+    REAL alphamin, alphamax, xi
+    INTEGER i, j, ilon, ilat
+    CHARACTER(LEN = 20), parameter :: modname = "tau2alpha"
+
+    alphamin = factt / taumax
+    alphamax = factt / taumin
     IF (guide_reg.OR.guide_add) THEN
-        alpha=alphamax
-!-----------------------------------------------------------------------
-! guide_reg: alpha=alpha_min dans region, 0. sinon.
-!-----------------------------------------------------------------------
-        IF (guide_reg) THEN
-            do j=jjb,jje
-                do i=1,pim
-                    if (typ==2) THEN
-                       zlat=rlatu(j)*180./pi
-                       zlon=rlonu(i)*180./pi
-                    elseif (typ==1) THEN
-                       zlat=rlatu(j)*180./pi
-                       zlon=rlonv(i)*180./pi
-                    elseif (typ==3) THEN
-                       zlat=rlatv(j)*180./pi
-                       zlon=rlonv(i)*180./pi
-                    endif
-                    alpha(i,j)=alphamax/16.* &
-                              (1.+tanh((zlat-lat_min_g)/tau_lat))* &
-                              (1.+tanh((lat_max_g-zlat)/tau_lat))* &
-                              (1.+tanh((zlon-lon_min_g)/tau_lon))* &
-                              (1.+tanh((lon_max_g-zlon)/tau_lon))
-                enddo
-            enddo
-        ENDIF
+      alpha = alphamax
+      !-----------------------------------------------------------------------
+      ! guide_reg: alpha=alpha_min dans region, 0. sinon.
+      !-----------------------------------------------------------------------
+      IF (guide_reg) THEN
+        do j = jjb, jje
+          do i = 1, pim
+            IF (typ==2) THEN
+              zlat = rlatu(j) * 180. / pi
+              zlon = rlonu(i) * 180. / pi
+            elseif (typ==1) THEN
+              zlat = rlatu(j) * 180. / pi
+              zlon = rlonv(i) * 180. / pi
+            elseif (typ==3) THEN
+              zlat = rlatv(j) * 180. / pi
+              zlon = rlonv(i) * 180. / pi
+            endif
+            alpha(i, j) = alphamax / 16. * &
+                    (1. + tanh((zlat - lat_min_g) / tau_lat)) * &
+                    (1. + tanh((lat_max_g - zlat) / tau_lat)) * &
+                    (1. + tanh((zlon - lon_min_g) / tau_lon)) * &
+                    (1. + tanh((lon_max_g - zlon) / tau_lon))
+          enddo
+        enddo
+      ENDIF
     ELSE
-!-----------------------------------------------------------------------
-! Sinon, alpha varie entre alpha_min et alpha_max suivant le zoom.
-!-----------------------------------------------------------------------
-!Calcul de l'aire des mailles
-        do j=2,jjm
-            do i=2,iip1
-               zdx(i,j)=0.5*(cu(i-1,j)+cu(i,j))/cos(rlatu(j))
-            enddo
-            zdx(1,j)=zdx(iip1,j)
+      !-----------------------------------------------------------------------
+      ! Sinon, alpha varie entre alpha_min et alpha_max suivant le zoom.
+      !-----------------------------------------------------------------------
+      !Calcul de l'aire des mailles
+      do j = 2, jjm
+        do i = 2, iip1
+          zdx(i, j) = 0.5 * (cu(i - 1, j) + cu(i, j)) / cos(rlatu(j))
         enddo
-        do j=2,jjm
-            do i=1,iip1
-               zdy(i,j)=0.5*(cv(i,j-1)+cv(i,j))
-            enddo
+        zdx(1, j) = zdx(iip1, j)
+      enddo
+      do j = 2, jjm
+        do i = 1, iip1
+          zdy(i, j) = 0.5 * (cv(i, j - 1) + cv(i, j))
         enddo
-        do i=1,iip1
-            zdx(i,1)=zdx(i,2)
-            zdx(i,jjp1)=zdx(i,jjm)
-            zdy(i,1)=zdy(i,2)
-            zdy(i,jjp1)=zdy(i,jjm)
+      enddo
+      do i = 1, iip1
+        zdx(i, 1) = zdx(i, 2)
+        zdx(i, jjp1) = zdx(i, jjm)
+        zdy(i, 1) = zdy(i, 2)
+        zdy(i, jjp1) = zdy(i, jjm)
+      enddo
+      do j = 1, jjp1
+        do i = 1, iip1
+          dxdys(i, j) = sqrt(zdx(i, j) * zdx(i, j) + zdy(i, j) * zdy(i, j))
         enddo
-        do j=1,jjp1
-            do i=1,iip1
-               dxdys(i,j)=sqrt(zdx(i,j)*zdx(i,j)+zdy(i,j)*zdy(i,j))
-            enddo
+      enddo
+      IF (typ==2) THEN
+        do j = 1, jjp1
+          do i = 1, iim
+            dxdyu(i, j) = 0.5 * (dxdys(i, j) + dxdys(i + 1, j))
+          enddo
+          dxdyu(iip1, j) = dxdyu(1, j)
         enddo
-        IF (typ==2) THEN
-            do j=1,jjp1
-                do i=1,iim
-                   dxdyu(i,j)=0.5*(dxdys(i,j)+dxdys(i+1,j))
-                enddo
-                dxdyu(iip1,j)=dxdyu(1,j)
-            enddo
-        ENDIF
-        IF (typ==3) THEN
-            do j=1,jjm
-                do i=1,iip1
-                   dxdyv(i,j)=0.5*(dxdys(i,j)+dxdys(i,j+1))
-                enddo
-            enddo
-        ENDIF
-! Premier appel: calcul des aires min et max et de gamma.
-        IF (first) THEN 
-            first=.FALSE.
-            ! coordonnees du centre du zoom
-            CALL coordij(clon,clat,ilon,ilat) 
-            ! aire de la maille au centre du zoom
-            dxdy_min=dxdys(ilon,ilat)
-            ! dxdy maximale de la maille
-            dxdy_max=0.
-            do j=1,jjp1
-                do i=1,iip1
-                     dxdy_max=max(dxdy_max,dxdys(i,j))
-                enddo
-            enddo
-            ! Calcul de gamma
-            if (abs(grossismx-1.)<0.1.or.abs(grossismy-1.)<0.1) THEN
-              WRITE(*,*)trim(modname)//' ATTENTION modele peu zoome'
-              WRITE(*,*)trim(modname)//' ATTENTION on prend une constante de guidage cste'
-              gamma=0.
+      ENDIF
+      IF (typ==3) THEN
+        do j = 1, jjm
+          do i = 1, iip1
+            dxdyv(i, j) = 0.5 * (dxdys(i, j) + dxdys(i, j + 1))
+          enddo
+        enddo
+      ENDIF
+      ! Premier appel: calcul des aires min et max et de gamma.
+      IF (first) THEN
+        first = .FALSE.
+        ! coordonnees du centre du zoom
+        CALL coordij(clon, clat, ilon, ilat)
+        ! aire de la maille au centre du zoom
+        dxdy_min = dxdys(ilon, ilat)
+        ! dxdy maximale de la maille
+        dxdy_max = 0.
+        do j = 1, jjp1
+          do i = 1, iip1
+            dxdy_max = max(dxdy_max, dxdys(i, j))
+          enddo
+        enddo
+        ! Calcul de gamma
+        IF (abs(grossismx - 1.)<0.1.OR.abs(grossismy - 1.)<0.1) THEN
+          WRITE(*, *)trim(modname) // ' ATTENTION modele peu zoome'
+          WRITE(*, *)trim(modname) // ' ATTENTION on prend une constante de guidage cste'
+          gamma = 0.
+        else
+          gamma = (dxdy_max - 2. * dxdy_min) / (dxdy_max - dxdy_min)
+          WRITE(*, *)trim(modname) // ' gamma=', gamma
+          IF (gamma<1.e-5) THEN
+            WRITE(*, *)trim(modname) // ' gamma =', gamma, '<1e-5'
+            CALL abort_gcm("guide_loc_mod", "stopped", 1)
+          endif
+          gamma = log(0.5) / log(gamma)
+          IF (gamma4) THEN
+            gamma = min(gamma, 4.)
+          endif
+          WRITE(*, *)trim(modname) // ' gamma=', gamma
+        endif
+      ENDIF !first
+
+      do j = jjb, jje
+        do i = 1, pim
+          IF (typ==1) THEN
+            dxdy_ = dxdys(i, j)
+            zlat = rlatu(j) * 180. / pi
+          elseif (typ==2) THEN
+            dxdy_ = dxdyu(i, j)
+            zlat = rlatu(j) * 180. / pi
+          elseif (typ==3) THEN
+            dxdy_ = dxdyv(i, j)
+            zlat = rlatv(j) * 180. / pi
+          endif
+          IF (abs(grossismx - 1.)<0.1.OR.abs(grossismy - 1.)<0.1) THEN
+            ! pour une grille reguliere, xi=xxx**0=1 -> alpha=alphamin
+            alpha(i, j) = alphamin
+          else
+            xi = ((dxdy_max - dxdy_) / (dxdy_max - dxdy_min))**gamma
+            xi = min(xi, 1.)
+            IF(lat_min_g<=zlat .AND. zlat<=lat_max_g) THEN
+              alpha(i, j) = xi * alphamin + (1. - xi) * alphamax
             else
-              gamma=(dxdy_max-2.*dxdy_min)/(dxdy_max-dxdy_min)
-              WRITE(*,*)trim(modname)//' gamma=',gamma
-              if (gamma<1.e-5) THEN
-                WRITE(*,*)trim(modname)//' gamma =',gamma,'<1e-5'
-                CALL abort_gcm("guide_loc_mod","stopped",1)
-              endif
-              gamma=log(0.5)/log(gamma)
-              if (gamma4) THEN
-                gamma=min(gamma,4.)
-              endif
-              WRITE(*,*)trim(modname)//' gamma=',gamma
+              alpha(i, j) = 0.
             endif
-        ENDIF !first
-
-        do j=jjb,jje
-            do i=1,pim
-                if (typ==1) THEN
-                   dxdy_=dxdys(i,j)
-                   zlat=rlatu(j)*180./pi
-                elseif (typ==2) THEN
-                   dxdy_=dxdyu(i,j)
-                   zlat=rlatu(j)*180./pi
-                elseif (typ==3) THEN
-                   dxdy_=dxdyv(i,j)
-                   zlat=rlatv(j)*180./pi
-                endif
-                if (abs(grossismx-1.)<0.1.or.abs(grossismy-1.)<0.1) THEN
-                ! pour une grille reguliere, xi=xxx**0=1 -> alpha=alphamin
-                    alpha(i,j)=alphamin
-                else
-                    xi=((dxdy_max-dxdy_)/(dxdy_max-dxdy_min))**gamma
-                    xi=min(xi,1.)
-                    IF(lat_min_g<=zlat .and. zlat<=lat_max_g) THEN
-                        alpha(i,j)=xi*alphamin+(1.-xi)*alphamax
-                    else
-                        alpha(i,j)=0.
-                    endif
-                endif
-            enddo
+          endif
         enddo
+      enddo
     ENDIF ! guide_reg
 
-    if (.not. guide_add) alpha = 1. - exp(- alpha)
+    IF (.NOT. guide_add) alpha = 1. - exp(- alpha)
 
   END SUBROUTINE tau2alpha
 
-!=======================================================================
+  !=======================================================================
   SUBROUTINE guide_read(timestep)
 
